'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _cssModulesFlowTypesPrinter = _interopRequireWildcard(require("css-modules-flow-types-printer"));

var _fileSystemLoader = _interopRequireDefault(require("./css-modules/fileSystemLoader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Converter = /*#__PURE__*/function () {
  function Converter(rootDir, eol) {
    _classCallCheck(this, Converter);

    this.loader = new _fileSystemLoader.default(rootDir);
    this.eol = eol;
  }

  _createClass(Converter, [{
    key: "convert",
    value: function convert(filePath) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        // TODO: benchmark this (maybe this should only be cleared when watching)
        _this.loader.tokensByFile = {};

        _this.loader.fetch(filePath, '/', undefined, undefined).then(function (res) {
          if (res) {
            var tokens = Object.keys(res);
            var content = (0, _cssModulesFlowTypesPrinter.default)(tokens, _this.eol || (0, _cssModulesFlowTypesPrinter.getLineSeparator)(tokens[0]));
            resolve(content);
          } else {
            reject(res);
          }
        }).catch(function (err) {
          return reject(err);
        });
      });
    }
  }]);

  return Converter;
}();

exports.default = Converter;