'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = writeFile;

var _fs = _interopRequireDefault(require("fs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function writeFile(outputFilePath, content) {
  return new Promise(function (resolve, reject) {
    _fs.default.writeFile(outputFilePath, content, 'utf8', function (err) {
      if (err) {
        reject(err);
      } else {
        resolve(outputFilePath);
      }
    });
  });
}